Đến nội dung


Hình ảnh
- - - - -

[Nhờ tư vấn] Lọc đối tượng (Point, Text) theo điều kiện


  • Please log in to reply
7 replies to this topic

#1 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 25 September 2013 - 11:13 AM

Chào các bác!

Lâu lắm rồi em mới quay trở lại diễn đàn để tiếp tục nghiên cứu lisp. Cũng lâu rồi em cũng chưa trau dồi được nhiều kiến thức nên lần này mong các bác chỉ giáo để em được mở rộng tầm nhìn.

 

Đầu vào:

Em có một tập chọn:

(setq ss (ssget '((0 . "TEXT"))))

Và một điểm Point

(setq Pnt (getpoint “\nChon 1 diem: ”))

 

Đầu ra:

Là một tập đối tượng được lọc theo điều kiện

 

Điều kiện:

Những đối tượng ( Text) có tọa độ Y nằm trong khoảng (- (Cadr Pnt) 4 ; + (Cadr Pnt) 4) thì được chọn ra một tập đối tượng mới.

 

Lâu rồi em cũng không mần nên còn gặp nhiều vướng mắc.

Em dùng cấu trúc này nhưng chưa ra

; Lấy mã Text

(defun TD:Text-Base (ent)

  (setq Ma10  (cdr (assoc 10 (entget ent))))

  (setq Ma11  (cdr (assoc 11 (entget ent))))

  (setq X11 (car Ma11))

  (setq Ma71  (cdr (assoc 71 (entget ent))))

  (setq Ma72  (cdr (assoc 72 (entget ent))))

  (if (or (and (= Ma71 0) (= Ma72 0) (= X11 0))

              (and (= Ma71 0) (= Ma72 3) )

              (and (= Ma71 0) (= Ma72 5) )

      )

    Ma10

    Ma11

   )

)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq ss (ssget '((0 . "TEXT")) ))

(setq Pnt (getpoint "\nChon diem:"))

(setq a 4)

(vl-remove-if-not '(lambda(m) (< (- (cadr Pnt) a) (cadr (TD:Text-Base (car m))) (+ (cadr Pnt) a))) (acet-ss-to-list ss))

 

Mong các bác chỉ giúp.


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn







#2 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5679 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 25 September 2013 - 11:25 AM

acet-ss-to-lít đã trả về list ename rồi, bác lấy TD:Text-Base Car ở dòng cuối cùng nên lỗi


  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#3 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 25 September 2013 - 11:28 AM

Có lẽ anh chưa dùng hàm này bao giờ nên bị lỗi. Ketxu làm mẫu cho anh 1 đoạn nhé! Anh mần cái này mãi chưa dc.


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn







#4 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5679 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 25 September 2013 - 11:31 AM

Bác bỏ cái car đi :( 

(vl-remove-if-not '(lambda(m) (< (- (cadr Pnt) a) (cadr (TD:Text-Base (car m))) (+ (cadr Pnt) a))) (acet-ss-to-list ss))


  • 1

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#5 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 25 September 2013 - 11:38 AM

Tham khảo đoạn code chọn TEXT có tung độ từ 800 đến 1000 thì bạn sẽ tìm ra cách thôi:

(ssget '((-4 . "<AND") (0 . "TEXT") (-4 . "*,<,*") (10 0 1000 0) (-4 . "*,>,*") (10 0 800 0) (-4 . "AND>")))


  • 3

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#6 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 25 September 2013 - 11:46 AM

Bác bỏ cái car đi :(

(vl-remove-if-not '(lambda(m) (< (- (cadr Pnt) a) (cadr (TD:Text-Base (car m))) (+ (cadr Pnt) a))) (acet-ss-to-list ss))

Tuyệt vời em ạ. Anh làm được rồi. Cảm ơn em nhiều

 

Tham khảo đoạn code chọn TEXT có tung độ từ 800 đến 1000 thì bạn sẽ tìm ra cách thôi:

(ssget '((-4 . "<AND") (0 . "TEXT") (-4 . "*,<,*") (10 0 1000 0) (-4 . "*,>,*") (10 0 800 0) (-4 . "AND>")))

Dạ, cảm ơn bác Hà.


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn







#7 phamthanhbinh

phamthanhbinh

    biết lệnh adcenter

  • Moderator
  • PipPipPipPipPipPipPip
  • 6007 Bài viết
Điểm đánh giá: 3113 (tuyệt vời)

Đã gửi 25 September 2013 - 12:40 PM

Chào các bác!

Lâu lắm rồi em mới quay trở lại diễn đàn để tiếp tục nghiên cứu lisp. Cũng lâu rồi em cũng chưa trau dồi được nhiều kiến thức nên lần này mong các bác chỉ giáo để em được mở rộng tầm nhìn.

 

Đầu vào:

Em có một tập chọn:

(setq ss (ssget '((0 . "TEXT"))))

Và một điểm Point

(setq Pnt (getpoint “\nChon 1 diem: ”))

 

Đầu ra:

Là một tập đối tượng được lọc theo điều kiện

 

Điều kiện:

Những đối tượng ( Text) có tọa độ Y nằm trong khoảng (- (Cadr Pnt) 4 ; + (Cadr Pnt) 4) thì được chọn ra một tập đối tượng mới.

 

Lâu rồi em cũng không mần nên còn gặp nhiều vướng mắc.

Em dùng cấu trúc này nhưng chưa ra

 

Mong các bác chỉ giúp.

Hề hề hề,

Cách của bác Hà là khá siêu cấp rồi.

Tuy nhiên dù chưa hiểu rõ về các hàm lựa chọn với toán tử này thì bác Thanhduan cũng có thể tự làm được với một cái lisp khá cồng kềnh như sau:

1/- Chọn tập ss với hàm ssget bao gồm các text cần phân loại. Lập một tập ss1 rỗng để lấy các đối tượng phù hợp với tiêu chí lựa chọn đặt ra

2/- Tạo một vòng lặp while qua tập này để :

     a/- Phân loại các đối tượng text theo mã 72 và 73 để lấy điểm đặt của text với hàm điều kiện (if ....)

     b/- Lấy ename của các text có điều kiện về điểm đặt phù hợp với tiêu chí  bằng hàm (if ...) và nhét nó vào trong tập chọn ss1 bằng hàng (append ....) hay hàm (cons ....)

 

Những điều này mình nghĩ bác Thanhduan cũng đã khá thông tỏ nhưng chắc là có quên tí ti về các mã dxf của text mà thôi. Bác cứ xem lại trong Help developer của CAD là tỏng ngay ấy mà....

Chúc bác thành công.


  • 1
Chúc các quý Anh trên diễn đàn luôn khỏe, đẻ thêm được nhiều thứ để mót.

#8 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 01 October 2013 - 01:05 PM

Hề hề hề,

Cách của bác Hà là khá siêu cấp rồi.

Tuy nhiên dù chưa hiểu rõ về các hàm lựa chọn với toán tử này thì bác Thanhduan cũng có thể tự làm được với một cái lisp khá cồng kềnh như sau:

1/- Chọn tập ss với hàm ssget bao gồm các text cần phân loại. Lập một tập ss1 rỗng để lấy các đối tượng phù hợp với tiêu chí lựa chọn đặt ra

2/- Tạo một vòng lặp while qua tập này để :

     a/- Phân loại các đối tượng text theo mã 72 và 73 để lấy điểm đặt của text với hàm điều kiện (if ....)

     b/- Lấy ename của các text có điều kiện về điểm đặt phù hợp với tiêu chí  bằng hàm (if ...) và nhét nó vào trong tập chọn ss1 bằng hàng (append ....) hay hàm (cons ....)

 

Những điều này mình nghĩ bác Thanhduan cũng đã khá thông tỏ nhưng chắc là có quên tí ti về các mã dxf của text mà thôi. Bác cứ xem lại trong Help developer của CAD là tỏng ngay ấy mà....

Chúc bác thành công.

Dạ, sau khi ketxu chỉ cho như vậy em làm được rồi bác phamthanhbinh ạ!
Sau hàm này em hiểu được 1 số vấn đề. Tại lâu rồi không ngâm nên lại hỏi làm phiền các bác. ^^

Đây là 1 phần nhỏ trong 1 bài toán nhớn bác Bình ạ. Hi


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn